/*******************************************************************************
 * This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at 
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     Peter Smith
 *******************************************************************************/
package org.boris.jxll;

public class XLCommandNumber
{
    /*
     ** Function number bits
     */
    public static final int xlCommand = 0x8000;
    public static final int xlSpecial = 0x4000;
    public static final int xlIntl = 0x2000;
    public static final int xlPrompt = 0x1000;

    /* Excel command numbers */
    public static final int xlcBeep = (0 | xlCommand);
    public static final int xlcOpen = (1 | xlCommand);
    public static final int xlcOpenLinks = (2 | xlCommand);
    public static final int xlcCloseAll = (3 | xlCommand);
    public static final int xlcSave = (4 | xlCommand);
    public static final int xlcSaveAs = (5 | xlCommand);
    public static final int xlcFileDelete = (6 | xlCommand);
    public static final int xlcPageSetup = (7 | xlCommand);
    public static final int xlcPrint = (8 | xlCommand);
    public static final int xlcPrinterSetup = (9 | xlCommand);
    public static final int xlcQuit = (10 | xlCommand);
    public static final int xlcNewWindow = (11 | xlCommand);
    public static final int xlcArrangeAll = (12 | xlCommand);
    public static final int xlcWindowSize = (13 | xlCommand);
    public static final int xlcWindowMove = (14 | xlCommand);
    public static final int xlcFull = (15 | xlCommand);
    public static final int xlcClose = (16 | xlCommand);
    public static final int xlcRun = (17 | xlCommand);
    public static final int xlcSetPrintArea = (22 | xlCommand);
    public static final int xlcSetPrintTitles = (23 | xlCommand);
    public static final int xlcSetPageBreak = (24 | xlCommand);
    public static final int xlcRemovePageBreak = (25 | xlCommand);
    public static final int xlcFont = (26 | xlCommand);
    public static final int xlcDisplay = (27 | xlCommand);
    public static final int xlcProtectDocument = (28 | xlCommand);
    public static final int xlcPrecision = (29 | xlCommand);
    public static final int xlcA1R1c1 = (30 | xlCommand);
    public static final int xlcCalculateNow = (31 | xlCommand);
    public static final int xlcCalculation = (32 | xlCommand);
    public static final int xlcDataFind = (34 | xlCommand);
    public static final int xlcExtract = (35 | xlCommand);
    public static final int xlcDataDelete = (36 | xlCommand);
    public static final int xlcSetDatabase = (37 | xlCommand);
    public static final int xlcSetCriteria = (38 | xlCommand);
    public static final int xlcSort = (39 | xlCommand);
    public static final int xlcDataSeries = (40 | xlCommand);
    public static final int xlcTable = (41 | xlCommand);
    public static final int xlcFormatNumber = (42 | xlCommand);
    public static final int xlcAlignment = (43 | xlCommand);
    public static final int xlcStyle = (44 | xlCommand);
    public static final int xlcBorder = (45 | xlCommand);
    public static final int xlcCellProtection = (46 | xlCommand);
    public static final int xlcColumnWidth = (47 | xlCommand);
    public static final int xlcUndo = (48 | xlCommand);
    public static final int xlcCut = (49 | xlCommand);
    public static final int xlcCopy = (50 | xlCommand);
    public static final int xlcPaste = (51 | xlCommand);
    public static final int xlcClear = (52 | xlCommand);
    public static final int xlcPasteSpecial = (53 | xlCommand);
    public static final int xlcEditDelete = (54 | xlCommand);
    public static final int xlcInsert = (55 | xlCommand);
    public static final int xlcFillRight = (56 | xlCommand);
    public static final int xlcFillDown = (57 | xlCommand);
    public static final int xlcDefineName = (61 | xlCommand);
    public static final int xlcCreateNames = (62 | xlCommand);
    public static final int xlcFormulaGoto = (63 | xlCommand);
    public static final int xlcFormulaFind = (64 | xlCommand);
    public static final int xlcSelectLastCell = (65 | xlCommand);
    public static final int xlcShowActiveCell = (66 | xlCommand);
    public static final int xlcGalleryArea = (67 | xlCommand);
    public static final int xlcGalleryBar = (68 | xlCommand);
    public static final int xlcGalleryColumn = (69 | xlCommand);
    public static final int xlcGalleryLine = (70 | xlCommand);
    public static final int xlcGalleryPie = (71 | xlCommand);
    public static final int xlcGalleryScatter = (72 | xlCommand);
    public static final int xlcCombination = (73 | xlCommand);
    public static final int xlcPreferred = (74 | xlCommand);
    public static final int xlcAddOverlay = (75 | xlCommand);
    public static final int xlcGridlines = (76 | xlCommand);
    public static final int xlcSetPreferred = (77 | xlCommand);
    public static final int xlcAxes = (78 | xlCommand);
    public static final int xlcLegend = (79 | xlCommand);
    public static final int xlcAttachText = (80 | xlCommand);
    public static final int xlcAddArrow = (81 | xlCommand);
    public static final int xlcSelectChart = (82 | xlCommand);
    public static final int xlcSelectPlotArea = (83 | xlCommand);
    public static final int xlcPatterns = (84 | xlCommand);
    public static final int xlcMainChart = (85 | xlCommand);
    public static final int xlcOverlay = (86 | xlCommand);
    public static final int xlcScale = (87 | xlCommand);
    public static final int xlcFormatLegend = (88 | xlCommand);
    public static final int xlcFormatText = (89 | xlCommand);
    public static final int xlcEditRepeat = (90 | xlCommand);
    public static final int xlcParse = (91 | xlCommand);
    public static final int xlcJustify = (92 | xlCommand);
    public static final int xlcHide = (93 | xlCommand);
    public static final int xlcUnhide = (94 | xlCommand);
    public static final int xlcWorkspace = (95 | xlCommand);
    public static final int xlcFormula = (96 | xlCommand);
    public static final int xlcFormulaFill = (97 | xlCommand);
    public static final int xlcFormulaArray = (98 | xlCommand);
    public static final int xlcDataFindNext = (99 | xlCommand);
    public static final int xlcDataFindPrev = (100 | xlCommand);
    public static final int xlcFormulaFindNext = (101 | xlCommand);
    public static final int xlcFormulaFindPrev = (102 | xlCommand);
    public static final int xlcActivate = (103 | xlCommand);
    public static final int xlcActivateNext = (104 | xlCommand);
    public static final int xlcActivatePrev = (105 | xlCommand);
    public static final int xlcUnlockedNext = (106 | xlCommand);
    public static final int xlcUnlockedPrev = (107 | xlCommand);
    public static final int xlcCopyPicture = (108 | xlCommand);
    public static final int xlcSelect = (109 | xlCommand);
    public static final int xlcDeleteName = (110 | xlCommand);
    public static final int xlcDeleteFormat = (111 | xlCommand);
    public static final int xlcVline = (112 | xlCommand);
    public static final int xlcHline = (113 | xlCommand);
    public static final int xlcVpage = (114 | xlCommand);
    public static final int xlcHpage = (115 | xlCommand);
    public static final int xlcVscroll = (116 | xlCommand);
    public static final int xlcHscroll = (117 | xlCommand);
    public static final int xlcAlert = (118 | xlCommand);
    public static final int xlcNew = (119 | xlCommand);
    public static final int xlcCancelCopy = (120 | xlCommand);
    public static final int xlcShowClipboard = (121 | xlCommand);
    public static final int xlcMessage = (122 | xlCommand);
    public static final int xlcPasteLink = (124 | xlCommand);
    public static final int xlcAppActivate = (125 | xlCommand);
    public static final int xlcDeleteArrow = (126 | xlCommand);
    public static final int xlcRowHeight = (127 | xlCommand);
    public static final int xlcFormatMove = (128 | xlCommand);
    public static final int xlcFormatSize = (129 | xlCommand);
    public static final int xlcFormulaReplace = (130 | xlCommand);
    public static final int xlcSendKeys = (131 | xlCommand);
    public static final int xlcSelectSpecial = (132 | xlCommand);
    public static final int xlcApplyNames = (133 | xlCommand);
    public static final int xlcReplaceFont = (134 | xlCommand);
    public static final int xlcFreezePanes = (135 | xlCommand);
    public static final int xlcShowInfo = (136 | xlCommand);
    public static final int xlcSplit = (137 | xlCommand);
    public static final int xlcOnWindow = (138 | xlCommand);
    public static final int xlcOnData = (139 | xlCommand);
    public static final int xlcDisableInput = (140 | xlCommand);
    public static final int xlcEcho = (141 | xlCommand);
    public static final int xlcOutline = (142 | xlCommand);
    public static final int xlcListNames = (143 | xlCommand);
    public static final int xlcFileClose = (144 | xlCommand);
    public static final int xlcSaveWorkbook = (145 | xlCommand);
    public static final int xlcDataForm = (146 | xlCommand);
    public static final int xlcCopyChart = (147 | xlCommand);
    public static final int xlcOnTime = (148 | xlCommand);
    public static final int xlcWait = (149 | xlCommand);
    public static final int xlcFormatFont = (150 | xlCommand);
    public static final int xlcFillUp = (151 | xlCommand);
    public static final int xlcFillLeft = (152 | xlCommand);
    public static final int xlcDeleteOverlay = (153 | xlCommand);
    public static final int xlcNote = (154 | xlCommand);
    public static final int xlcShortMenus = (155 | xlCommand);
    public static final int xlcSetUpdateStatus = (159 | xlCommand);
    public static final int xlcColorPalette = (161 | xlCommand);
    public static final int xlcDeleteStyle = (162 | xlCommand);
    public static final int xlcWindowRestore = (163 | xlCommand);
    public static final int xlcWindowMaximize = (164 | xlCommand);
    public static final int xlcError = (165 | xlCommand);
    public static final int xlcChangeLink = (166 | xlCommand);
    public static final int xlcCalculateDocument = (167 | xlCommand);
    public static final int xlcOnKey = (168 | xlCommand);
    public static final int xlcAppRestore = (169 | xlCommand);
    public static final int xlcAppMove = (170 | xlCommand);
    public static final int xlcAppSize = (171 | xlCommand);
    public static final int xlcAppMinimize = (172 | xlCommand);
    public static final int xlcAppMaximize = (173 | xlCommand);
    public static final int xlcBringToFront = (174 | xlCommand);
    public static final int xlcSendToBack = (175 | xlCommand);
    public static final int xlcMainChartType = (185 | xlCommand);
    public static final int xlcOverlayChartType = (186 | xlCommand);
    public static final int xlcSelectEnd = (187 | xlCommand);
    public static final int xlcOpenMail = (188 | xlCommand);
    public static final int xlcSendMail = (189 | xlCommand);
    public static final int xlcStandardFont = (190 | xlCommand);
    public static final int xlcConsolidate = (191 | xlCommand);
    public static final int xlcSortSpecial = (192 | xlCommand);
    public static final int xlcGallery3dArea = (193 | xlCommand);
    public static final int xlcGallery3dColumn = (194 | xlCommand);
    public static final int xlcGallery3dLine = (195 | xlCommand);
    public static final int xlcGallery3dPie = (196 | xlCommand);
    public static final int xlcView3d = (197 | xlCommand);
    public static final int xlcGoalSeek = (198 | xlCommand);
    public static final int xlcWorkgroup = (199 | xlCommand);
    public static final int xlcFillGroup = (200 | xlCommand);
    public static final int xlcUpdateLink = (201 | xlCommand);
    public static final int xlcPromote = (202 | xlCommand);
    public static final int xlcDemote = (203 | xlCommand);
    public static final int xlcShowDetail = (204 | xlCommand);
    public static final int xlcUngroup = (206 | xlCommand);
    public static final int xlcObjectProperties = (207 | xlCommand);
    public static final int xlcSaveNewObject = (208 | xlCommand);
    public static final int xlcShare = (209 | xlCommand);
    public static final int xlcShareName = (210 | xlCommand);
    public static final int xlcDuplicate = (211 | xlCommand);
    public static final int xlcApplyStyle = (212 | xlCommand);
    public static final int xlcAssignToObject = (213 | xlCommand);
    public static final int xlcObjectProtection = (214 | xlCommand);
    public static final int xlcHideObject = (215 | xlCommand);
    public static final int xlcSetExtract = (216 | xlCommand);
    public static final int xlcCreatePublisher = (217 | xlCommand);
    public static final int xlcSubscribeTo = (218 | xlCommand);
    public static final int xlcAttributes = (219 | xlCommand);
    public static final int xlcShowToolbar = (220 | xlCommand);
    public static final int xlcPrintPreview = (222 | xlCommand);
    public static final int xlcEditColor = (223 | xlCommand);
    public static final int xlcShowLevels = (224 | xlCommand);
    public static final int xlcFormatMain = (225 | xlCommand);
    public static final int xlcFormatOverlay = (226 | xlCommand);
    public static final int xlcOnRecalc = (227 | xlCommand);
    public static final int xlcEditSeries = (228 | xlCommand);
    public static final int xlcDefineStyle = (229 | xlCommand);
    public static final int xlcLinePrint = (240 | xlCommand);
    public static final int xlcEnterData = (243 | xlCommand);
    public static final int xlcGalleryRadar = (249 | xlCommand);
    public static final int xlcMergeStyles = (250 | xlCommand);
    public static final int xlcEditionOptions = (251 | xlCommand);
    public static final int xlcPastePicture = (252 | xlCommand);
    public static final int xlcPastePictureLink = (253 | xlCommand);
    public static final int xlcSpelling = (254 | xlCommand);
    public static final int xlcZoom = (256 | xlCommand);
    public static final int xlcResume = (258 | xlCommand);
    public static final int xlcInsertObject = (259 | xlCommand);
    public static final int xlcWindowMinimize = (260 | xlCommand);
    public static final int xlcSize = (261 | xlCommand);
    public static final int xlcMove = (262 | xlCommand);
    public static final int xlcSoundNote = (265 | xlCommand);
    public static final int xlcSoundPlay = (266 | xlCommand);
    public static final int xlcFormatShape = (267 | xlCommand);
    public static final int xlcExtendPolygon = (268 | xlCommand);
    public static final int xlcFormatAuto = (269 | xlCommand);
    public static final int xlcGallery3dBar = (272 | xlCommand);
    public static final int xlcGallery3dSurface = (273 | xlCommand);
    public static final int xlcFillAuto = (274 | xlCommand);
    public static final int xlcCustomizeToolbar = (276 | xlCommand);
    public static final int xlcAddTool = (277 | xlCommand);
    public static final int xlcEditObject = (278 | xlCommand);
    public static final int xlcOnDoubleclick = (279 | xlCommand);
    public static final int xlcOnEntry = (280 | xlCommand);
    public static final int xlcWorkbookAdd = (281 | xlCommand);
    public static final int xlcWorkbookMove = (282 | xlCommand);
    public static final int xlcWorkbookCopy = (283 | xlCommand);
    public static final int xlcWorkbookOptions = (284 | xlCommand);
    public static final int xlcSaveWorkspace = (285 | xlCommand);
    public static final int xlcChartWizard = (288 | xlCommand);
    public static final int xlcDeleteTool = (289 | xlCommand);
    public static final int xlcMoveTool = (290 | xlCommand);
    public static final int xlcWorkbookSelect = (291 | xlCommand);
    public static final int xlcWorkbookActivate = (292 | xlCommand);
    public static final int xlcAssignToTool = (293 | xlCommand);
    public static final int xlcCopyTool = (295 | xlCommand);
    public static final int xlcResetTool = (296 | xlCommand);
    public static final int xlcConstrainNumeric = (297 | xlCommand);
    public static final int xlcPasteTool = (298 | xlCommand);
    public static final int xlcPlacement = (300 | xlCommand);
    public static final int xlcFillWorkgroup = (301 | xlCommand);
    public static final int xlcWorkbookNew = (302 | xlCommand);
    public static final int xlcScenarioCells = (305 | xlCommand);
    public static final int xlcScenarioDelete = (306 | xlCommand);
    public static final int xlcScenarioAdd = (307 | xlCommand);
    public static final int xlcScenarioEdit = (308 | xlCommand);
    public static final int xlcScenarioShow = (309 | xlCommand);
    public static final int xlcScenarioShowNext = (310 | xlCommand);
    public static final int xlcScenarioSummary = (311 | xlCommand);
    public static final int xlcPivotTableWizard = (312 | xlCommand);
    public static final int xlcPivotFieldProperties = (313 | xlCommand);
    public static final int xlcPivotField = (314 | xlCommand);
    public static final int xlcPivotItem = (315 | xlCommand);
    public static final int xlcPivotAddFields = (316 | xlCommand);
    public static final int xlcOptionsCalculation = (318 | xlCommand);
    public static final int xlcOptionsEdit = (319 | xlCommand);
    public static final int xlcOptionsView = (320 | xlCommand);
    public static final int xlcAddinManager = (321 | xlCommand);
    public static final int xlcMenuEditor = (322 | xlCommand);
    public static final int xlcAttachToolbars = (323 | xlCommand);
    public static final int xlcVbaReset = (324 | xlCommand);
    public static final int xlcOptionsChart = (325 | xlCommand);
    public static final int xlcStart = (326 | xlCommand);
    public static final int xlcVbaEnd = (327 | xlCommand);
    public static final int xlcVbaInsertFile = (328 | xlCommand);
    public static final int xlcVbaProcedureDefinition = (330 | xlCommand);
    public static final int xlcVbaReferences = (331 | xlCommand);
    public static final int xlcVbaStepInto = (332 | xlCommand);
    public static final int xlcVbaStepOver = (333 | xlCommand);
    public static final int xlcVbaToggleBreakpoint = (334 | xlCommand);
    public static final int xlcVbaClearBreakpoints = (335 | xlCommand);
    public static final int xlcRoutingSlip = (336 | xlCommand);
    public static final int xlcRouteDocument = (338 | xlCommand);
    public static final int xlcMailLogon = (339 | xlCommand);
    public static final int xlcInsertPicture = (342 | xlCommand);
    public static final int xlcEditTool = (343 | xlCommand);
    public static final int xlcGalleryDoughnut = (344 | xlCommand);
    public static final int xlcVbaObjectBrowser = (345 | xlCommand);
    public static final int xlcVbaDebugWindow = (346 | xlCommand);
    public static final int xlcVbaAddWatch = (347 | xlCommand);
    public static final int xlcVbaEditWatch = (348 | xlCommand);
    public static final int xlcVbaInstantWatch = (349 | xlCommand);
    public static final int xlcChartTrend = (350 | xlCommand);
    public static final int xlcPivotItemProperties = (352 | xlCommand);
    public static final int xlcWorkbookInsert = (354 | xlCommand);
    public static final int xlcOptionsTransition = (355 | xlCommand);
    public static final int xlcOptionsGeneral = (356 | xlCommand);
    public static final int xlcFilterAdvanced = (370 | xlCommand);
    public static final int xlcMailAddMailer = (373 | xlCommand);
    public static final int xlcMailDeleteMailer = (374 | xlCommand);
    public static final int xlcMailReply = (375 | xlCommand);
    public static final int xlcMailReplyAll = (376 | xlCommand);
    public static final int xlcMailForward = (377 | xlCommand);
    public static final int xlcMailNextLetter = (378 | xlCommand);
    public static final int xlcDataLabel = (379 | xlCommand);
    public static final int xlcInsertTitle = (380 | xlCommand);
    public static final int xlcFontProperties = (381 | xlCommand);
    public static final int xlcMacroOptions = (382 | xlCommand);
    public static final int xlcWorkbookHide = (383 | xlCommand);
    public static final int xlcWorkbookUnhide = (384 | xlCommand);
    public static final int xlcWorkbookDelete = (385 | xlCommand);
    public static final int xlcWorkbookName = (386 | xlCommand);
    public static final int xlcGalleryCustom = (388 | xlCommand);
    public static final int xlcAddChartAutoformat = (390 | xlCommand);
    public static final int xlcDeleteChartAutoformat = (391 | xlCommand);
    public static final int xlcChartAddData = (392 | xlCommand);
    public static final int xlcAutoOutline = (393 | xlCommand);
    public static final int xlcTabOrder = (394 | xlCommand);
    public static final int xlcShowDialog = (395 | xlCommand);
    public static final int xlcSelectAll = (396 | xlCommand);
    public static final int xlcUngroupSheets = (397 | xlCommand);
    public static final int xlcSubtotalCreate = (398 | xlCommand);
    public static final int xlcSubtotalRemove = (399 | xlCommand);
    public static final int xlcRenameObject = (400 | xlCommand);
    public static final int xlcWorkbookScroll = (412 | xlCommand);
    public static final int xlcWorkbookNext = (413 | xlCommand);
    public static final int xlcWorkbookPrev = (414 | xlCommand);
    public static final int xlcWorkbookTabSplit = (415 | xlCommand);
    public static final int xlcFullScreen = (416 | xlCommand);
    public static final int xlcWorkbookProtect = (417 | xlCommand);
    public static final int xlcScrollbarProperties = (420 | xlCommand);
    public static final int xlcPivotShowPages = (421 | xlCommand);
    public static final int xlcTextToColumns = (422 | xlCommand);
    public static final int xlcFormatCharttype = (423 | xlCommand);
    public static final int xlcLinkFormat = (424 | xlCommand);
    public static final int xlcTracerDisplay = (425 | xlCommand);
    public static final int xlcTracerNavigate = (430 | xlCommand);
    public static final int xlcTracerClear = (431 | xlCommand);
    public static final int xlcTracerError = (432 | xlCommand);
    public static final int xlcPivotFieldGroup = (433 | xlCommand);
    public static final int xlcPivotFieldUngroup = (434 | xlCommand);
    public static final int xlcCheckboxProperties = (435 | xlCommand);
    public static final int xlcLabelProperties = (436 | xlCommand);
    public static final int xlcListboxProperties = (437 | xlCommand);
    public static final int xlcEditboxProperties = (438 | xlCommand);
    public static final int xlcPivotRefresh = (439 | xlCommand);
    public static final int xlcLinkCombo = (440 | xlCommand);
    public static final int xlcOpenText = (441 | xlCommand);
    public static final int xlcHideDialog = (442 | xlCommand);
    public static final int xlcSetDialogFocus = (443 | xlCommand);
    public static final int xlcEnableObject = (444 | xlCommand);
    public static final int xlcPushbuttonProperties = (445 | xlCommand);
    public static final int xlcSetDialogDefault = (446 | xlCommand);
    public static final int xlcFilter = (447 | xlCommand);
    public static final int xlcFilterShowAll = (448 | xlCommand);
    public static final int xlcClearOutline = (449 | xlCommand);
    public static final int xlcFunctionWizard = (450 | xlCommand);
    public static final int xlcAddListItem = (451 | xlCommand);
    public static final int xlcSetListItem = (452 | xlCommand);
    public static final int xlcRemoveListItem = (453 | xlCommand);
    public static final int xlcSelectListItem = (454 | xlCommand);
    public static final int xlcSetControlValue = (455 | xlCommand);
    public static final int xlcSaveCopyAs = (456 | xlCommand);
    public static final int xlcOptionsListsAdd = (458 | xlCommand);
    public static final int xlcOptionsListsDelete = (459 | xlCommand);
    public static final int xlcSeriesAxes = (460 | xlCommand);
    public static final int xlcSeriesX = (461 | xlCommand);
    public static final int xlcSeriesY = (462 | xlCommand);
    public static final int xlcErrorbarX = (463 | xlCommand);
    public static final int xlcErrorbarY = (464 | xlCommand);
    public static final int xlcFormatChart = (465 | xlCommand);
    public static final int xlcSeriesOrder = (466 | xlCommand);
    public static final int xlcMailLogoff = (467 | xlCommand);
    public static final int xlcClearRoutingSlip = (468 | xlCommand);
    public static final int xlcAppActivateMicrosoft = (469 | xlCommand);
    public static final int xlcMailEditMailer = (470 | xlCommand);
    public static final int xlcOnSheet = (471 | xlCommand);
    public static final int xlcStandardWidth = (472 | xlCommand);
    public static final int xlcScenarioMerge = (473 | xlCommand);
    public static final int xlcSummaryInfo = (474 | xlCommand);
    public static final int xlcFindFile = (475 | xlCommand);
    public static final int xlcActiveCellFont = (476 | xlCommand);
    public static final int xlcEnableTipwizard = (477 | xlCommand);
    public static final int xlcVbaMakeAddin = (478 | xlCommand);
    public static final int xlcMailSendMailer = (482 | xlCommand);
}
